import ch.usi.dag.disl.annotation.After;
import ch.usi.dag.disl.annotation.Before;
import ch.usi.dag.disl.annotation.SyntheticLocal;
import ch.usi.dag.disl.marker.BodyMarker;

public class SimpleProfiler {

	@SyntheticLocal
	static long entryTime;

	@Before(marker = BodyMarker.class)
	static void onMethodEntry() {

		// sample entry time
		entryTime = System.nanoTime();
	}

	@After(marker = BodyMarker.class)
	static void onMethodExit() {
		
		// print method duration
		System.out.println("Instrumentation: Method duration " + (System.nanoTime() - entryTime) + " ns");
	}

}
