import ch.usi.dag.disl.annotation.After;
import ch.usi.dag.disl.annotation.Before;
import ch.usi.dag.disl.annotation.SyntheticLocal;
import ch.usi.dag.disl.marker.BodyMarker;
import ch.usi.dag.disl.staticcontext.MethodStaticContext;

public class SimpleProfiler {

	@SyntheticLocal
	static long entryTime;

	@Before(marker = BodyMarker.class)
	static void onMethodEntry() {

		// sample entry time
		entryTime = System.nanoTime();
	}

	@After(marker = BodyMarker.class)
	static void onMethodExit(MethodStaticContext msc) {

		// print method duration
		System.out.println("Instrumentation: " + msc.thisMethodFullName()
				+ " duration " + (System.nanoTime() - entryTime) + " ns");
	}
}
