import ch.usi.dag.disl.annotation.AfterReturning;
import ch.usi.dag.disl.annotation.Before;
import ch.usi.dag.disl.annotation.SyntheticLocal;
import ch.usi.dag.disl.dynamiccontext.DynamicContext;
import ch.usi.dag.disl.marker.BodyMarker;
import ch.usi.dag.disl.staticcontext.MethodStaticContext;

public class IdentityHashCode {

	@SyntheticLocal
	static long entryTime;

	@Before(marker = BodyMarker.class)
	static void onMethodEntry() {

		// sample entry time
		entryTime = System.nanoTime();
	}

	// NOTE: Accessing this object is not allowed in an exception handler in a constructor
	//        - reason for @AfterReturning
	@AfterReturning(marker = BodyMarker.class)
	static void onMethodExit(MethodStaticContext msc, DynamicContext dc) {

		// print method duration for object instance
		int identityHC = System.identityHashCode(dc.getThis());
		System.out.println("Instrumentation: " + msc.thisMethodFullName()
				+ " duration " + (System.nanoTime() - entryTime) + " ns"
				+ " - for object id " + identityHC);
	}
}
