import ch.usi.dag.disl.annotation.After;
import ch.usi.dag.disl.annotation.Before;
import ch.usi.dag.disl.annotation.SyntheticLocal;
import ch.usi.dag.disl.marker.BasicBlockMarker;
import ch.usi.dag.disl.staticcontext.MethodStaticContext;

public class SimpleProfiler {

	@SyntheticLocal
	static long entryTime;

	@Before(marker = BasicBlockMarker.class)
	static void onMethodEntry() {

		// sample entry time
		entryTime = System.nanoTime();
	}

	@After(marker = BasicBlockMarker.class)
	static void onMethodExit(MethodStaticContext msc) {

		// print duration for each basic block
		System.out.println("Instrumentation: " + msc.thisMethodFullName()
				+ " basic block duration " + (System.nanoTime() - entryTime));
	}

}
