import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.MethodInsnNode;

import ch.usi.dag.disl.exception.StaticContextException;
import ch.usi.dag.disl.staticcontext.AbstractStaticContext;
import ch.usi.dag.disl.util.Constants;

public class InvocationContext extends AbstractStaticContext {

	public String getCallee() {

		// get invocation instruction
		AbstractInsnNode insn = staticContextData.getRegionStart();

		// construct callee name
		if (insn instanceof MethodInsnNode) {
			MethodInsnNode min = (MethodInsnNode) insn;
			return min.owner + Constants.STATIC_CONTEXT_METHOD_DELIM + min.name;
		}

		throw new StaticContextException("InvocationContext can be used only with marked method invocation");
	}
}
