import ch.usi.dag.disl.annotation.After;
import ch.usi.dag.disl.annotation.Before;
import ch.usi.dag.disl.annotation.SyntheticLocal;
import ch.usi.dag.disl.staticcontext.MethodStaticContext;

public class SimpleProfiler {

	@SyntheticLocal
	static long entryTime;

	@Before(marker = MethodInvocationMarker.class)
	static void onMethodEntry() {

		// sample invocation method time
		entryTime = System.nanoTime();
	}

	@After(marker = MethodInvocationMarker.class)
	static void onMethodExit(MethodStaticContext msc, InvocationContext ic) {

		// print duration of the invoked method
		System.out.println("Instrumentation: " + ic.getCallee()
				+ " (invoked by " + msc.thisMethodFullName() + ") duration "
				+ (System.nanoTime() - entryTime));
	}

}
